package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.WFWorkflow;

/**
 * 实体[WFVersion] 数据对象
 */
@TableName(value = "T_SRFWFWFVERSION",resultMap = "WFVersionResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WFVersion extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFWorkflow wfworkflow;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String wfmodel;
    private String wfverlanrestag;
    private Integer wfversion;
    private String wfwfid;
    @TableField(exist = false)//逻辑属性
    private String wfwfname;
    @TableId(value= "wfwfversionid",type=IdType.UUID)//指定主键生成策略
    private String wfversionid;
    @TableField(value= "wfwfversionname")
    private String wfversionname;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[配置]
     *  @param wfmodel
     */
    public void setWfmodel(String wfmodel){
        if(StringUtils.isEmpty(wfmodel))
            wfmodel=null;
        this.wfmodel = wfmodel;
        this.set("wfmodeldirtyflag",true);
    }
    /**
     *  获取属性值[配置]
     */
    public String getWfmodel(){
        return this.wfmodel;
    }
    /**
     *  重置属性值[配置]
     */
    public void resetWfmodel(){
        this.set("wfmodeldirtyflag",false);
        this.wfmodel = null;
    }
    /**
     *  设置属性值[流程版本语言资源]
     *  @param wfverlanrestag
     */
    public void setWfverlanrestag(String wfverlanrestag){
        if(StringUtils.isEmpty(wfverlanrestag))
            wfverlanrestag=null;
        this.wfverlanrestag = wfverlanrestag;
        this.set("wfverlanrestagdirtyflag",true);
    }
    /**
     *  获取属性值[流程版本语言资源]
     */
    public String getWfverlanrestag(){
        return this.wfverlanrestag;
    }
    /**
     *  重置属性值[流程版本语言资源]
     */
    public void resetWfverlanrestag(){
        this.set("wfverlanrestagdirtyflag",false);
        this.wfverlanrestag = null;
    }
    /**
     *  设置属性值[版本]
     *  @param wfversion
     */
    public void setWfversion(Integer wfversion){
        this.wfversion = wfversion;
        this.set("wfversiondirtyflag",true);
    }
    /**
     *  获取属性值[版本]
     */
    public Integer getWfversion(){
        return this.wfversion;
    }
    /**
     *  重置属性值[版本]
     */
    public void resetWfversion(){
        this.set("wfversiondirtyflag",false);
        this.wfversion = null;
    }
    /**
     *  设置属性值[工作流配置]
     *  @param wfwfid
     */
    public void setWfwfid(String wfwfid){
        if(StringUtils.isEmpty(wfwfid))
            wfwfid=null;
        this.wfwfid = wfwfid;
        this.set("wfwfiddirtyflag",true);
    }
    /**
     *  获取属性值[工作流配置]
     */
    public String getWfwfid(){
        return this.wfwfid;
    }
    /**
     *  重置属性值[工作流配置]
     */
    public void resetWfwfid(){
        this.set("wfwfiddirtyflag",false);
        this.wfwfid = null;
    }
    /**
     *  设置属性值[工作流配置]
     *  @param wfwfname
     */
    public void setWfwfname(String wfwfname){
        if(StringUtils.isEmpty(wfwfname))
            wfwfname=null;
        this.wfwfname = wfwfname;
        this.set("wfwfnamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流配置]
     */
    public String getWfwfname(){
        return this.wfwfname;
    }
    /**
     *  重置属性值[工作流配置]
     */
    public void resetWfwfname(){
        this.set("wfwfnamedirtyflag",false);
        this.wfwfname = null;
    }
    /**
     *  设置属性值[工作流配置版本标识]
     *  @param wfversionid
     */
    public void setWfversionid(String wfversionid){
        if(StringUtils.isEmpty(wfversionid))
            wfversionid=null;
        this.wfversionid = wfversionid;
        this.set("wfversioniddirtyflag",true);
    }
     /**
     *    wfversionid :wfwfversionid
     *   当属性名称与代码名称不一致时，
     *   多发一套get属性名称方法给gridvo用
     */
    public String getWfwfversionid(){
        return  wfversionid;
    }
     /**
     *    wfversionid :wfwfversionid
     *   关闭mp驼峰转换，当属性名称与代码名称不一致时，多发一套set用于值注入
     */
    public void setWfwfversionid(String wfwfversionid){
        this.wfversionid=wfwfversionid;
    }
    /**
     *  获取属性值[工作流配置版本标识]
     */
    public String getWfversionid(){
        return this.wfversionid;
    }
    /**
     *  重置属性值[工作流配置版本标识]
     */
    public void resetWfversionid(){
        this.set("wfversioniddirtyflag",false);
        this.wfversionid = null;
    }
    /**
     *  设置属性值[工作流配置版本名称]
     *  @param wfversionname
     */
    public void setWfversionname(String wfversionname){
        if(StringUtils.isEmpty(wfversionname))
            wfversionname=null;
        this.wfversionname = wfversionname;
        this.set("wfversionnamedirtyflag",true);
    }
     /**
     *    wfversionname :wfwfversionname
     *   当属性名称与代码名称不一致时，
     *   多发一套get属性名称方法给gridvo用
     */
    public String getWfwfversionname(){
        return  wfversionname;
    }
     /**
     *    wfversionname :wfwfversionname
     *   关闭mp驼峰转换，当属性名称与代码名称不一致时，多发一套set用于值注入
     */
    public void setWfwfversionname(String wfwfversionname){
        this.wfversionname=wfwfversionname;
    }
    /**
     *  获取属性值[工作流配置版本名称]
     */
    public String getWfversionname(){
        return this.wfversionname;
    }
    /**
     *  重置属性值[工作流配置版本名称]
     */
    public void resetWfversionname(){
        this.set("wfversionnamedirtyflag",false);
        this.wfversionname = null;
    }
     /**
     *  获取主实体关联数据[WFWorkflow]
     */
    public WFWorkflow getWfworkflow() {
        return wfworkflow;
    }
    /**
     *  设置主实体关联数据[WFWorkflow]
     */
    public void setWfworkflow(WFWorkflow wfworkflow) {
        this.wfworkflow = wfworkflow;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetUpdatedate();
        resetUpdateman();
        resetWfmodel();
        resetWfverlanrestag();
        resetWfversion();
        resetWfwfid();
        resetWfwfname();
        resetWfversionid();
        resetWfversionname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WFVersion copyTo(WFVersion targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WFVersion.class, WFVersion.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWfversionid();
		return targetEntity;
	}
}